package com.malk.huaxiaojinshu.service.Impl;

import com.malk.huaxiaojinshu.service.DDHXService;
import com.malk.server.dingtalk.DDR;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.lang.reflect.Array;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service
@Slf4j
public class DDHXServiceImpl implements DDHXService {

    /**
     * 获取在职员工
     * @param access_token
     * @param status_list
     * @param offset
     * @param size
     * @return
     */
    @Override
    public Map getAllUserIdInfo(String access_token, String status_list, Number offset, Number size) {

        Map param = UtilMap.map("access_token", access_token);
        Map body = UtilMap.map("status_list, offset, size", status_list, offset,size);
        return (Map) DDR.doPost("https://oapi.dingtalk.com/topapi/smartwork/hrm/employee/queryonjob", null, param, body).getResult();

    }

    /**
     * 花名册
     * @param access_token
     * @param userId
     * @param appAgentId
     * @return
     */
    @Override
    public List<Map> getDDUserInfoById(String access_token, String userId, Number appAgentId) {
        Map param = UtilMap.map("access_token", access_token);
        Map body = UtilMap.map("userid_list, agentid", userId, appAgentId);
        return (List<Map>) DDR.doPost("https://oapi.dingtalk.com/topapi/smartwork/hrm/employee/v2/list", null, param, body).getResult();
    }

    /**
     * 获取考勤列表列定义
     * @param access_token
     * @return
     */
    @Override
    public Map getAttColumns(String access_token) {
        Map param = UtilMap.map("access_token", access_token);
        return (Map) DDR.doPost("https://oapi.dingtalk.com/topapi/attendance/getattcolumns", null, param, null).getResult();

    }

    /**
     * 通过列获取数据
     * @param access_token
     * @param userId
     * @param column_id_list
     * @param startTime
     * @param endTime
     * @return
     */
    @Override
    public Map getAttColumnsValue(String access_token, String userId, String column_id_list, String startTime, String endTime) {
        Map param = UtilMap.map("access_token", access_token);
        Map body = UtilMap.map("userid, column_id_list, from_date, to_date", userId, column_id_list, startTime, endTime);
        return (Map) DDR.doPost("https://oapi.dingtalk.com/topapi/attendance/getcolumnval", null, param, body).getResult();
    }

    @Override
    public Map getleavetimebynames(String access_token, String userId, String leave_names, String startTime, String endTime) {
        Map param = UtilMap.map("access_token", access_token);
        Map body = UtilMap.map("userid, leave_names, from_date, to_date", userId, leave_names, startTime, endTime);
        return (Map) DDR.doPost("https://oapi.dingtalk.com/topapi/attendance/getleavetimebynames", null, param, body).getResult();
    }


}
